/*
    webmail -- simple pop3/smtp web e-mail cgi
    Copyright (C) 2000-2004 Dan Cahill

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include "main.h"

#ifdef HAVE_ADDRESSBOOK

typedef struct {
	int contactid;
	time_t obj_ctime;
	time_t obj_mtime;
	char owner_user[51];
	char owner_host[51];
	char nickname[51];
	char surname[51];
	char givenname[51];
	char email1[51];
	char email2[51];
	char homenumber[26];
	char worknumber[26];
	char mobilenumber[26];
	char faxnumber[26];
} REC_CONTACT;

char *strncatf(char *dest, int maxlen, const char *format, ...)
{
	char *ptemp;
	va_list ap;

	ptemp=dest+strlen(dest);
	va_start(ap, format);
	vsnprintf(ptemp, maxlen, format, ap);
	va_end(ap);
	ptemp[maxlen-1]='\0';
	return dest;
}

int dbread_contact(REC_CONTACT *contact, int index)
{
	int sqr;

	memset(contact, 0, sizeof(REC_CONTACT));
	if (index==0) {
		contact->obj_ctime=time(NULL);
		contact->obj_mtime=time(NULL);
		return 0;
	}
	if ((sqr=sql_query("SELECT contactid, nickname, surname, givenname, email1, email2, homenumber, worknumber, mobilenumber, faxnumber from nwm_contacts WHERE owner_user = \"%s\" AND owner_host = \"%s\" AND contactid = %d", user.username, user.pop3server, index))<0) return -1;
	if (sql_numtuples(sqr)!=1) {
		sql_freeresult(sqr);
		return -2;
	}
	contact->contactid = atoi(sql_getvalue(sqr, 0, 0));
	contact->obj_ctime=time(NULL);
	contact->obj_mtime=time(NULL);
	strncpy(contact->nickname,	sql_getvalue(sqr, 0, 1), sizeof(contact->nickname)-1);
	strncpy(contact->surname,	sql_getvalue(sqr, 0, 2), sizeof(contact->surname)-1);
	strncpy(contact->givenname,	sql_getvalue(sqr, 0, 3), sizeof(contact->givenname)-1);
	strncpy(contact->email1,	sql_getvalue(sqr, 0, 4), sizeof(contact->email1)-1);
	strncpy(contact->email2,	sql_getvalue(sqr, 0, 5), sizeof(contact->email2)-1);
	strncpy(contact->homenumber,	sql_getvalue(sqr, 0, 6), sizeof(contact->homenumber)-1);
	strncpy(contact->worknumber,	sql_getvalue(sqr, 0, 7), sizeof(contact->worknumber)-1);
	strncpy(contact->mobilenumber,	sql_getvalue(sqr, 0, 8), sizeof(contact->mobilenumber)-1);
	strncpy(contact->faxnumber,	sql_getvalue(sqr, 0, 9), sizeof(contact->faxnumber)-1);
	sql_freeresult(sqr);
	return 0;
}

void wmaddr_popup()
{
	char *ptemp;
	char field[10];
	char realname1[80];
	char realname2[80];
	int i, j;
	int sqr;

	send_header(0, "1", "text/html", -1, -1);
	printf("<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.0 Transitional//EN\">\r\n");
	printf("<HTML>\r\n<HEAD>\r\n<TITLE>%s</TITLE>\r\n", NWM_SERVERNAME);
	printf("<META HTTP-EQUIV=\"Content-Type\" CONTENT=\"text/html; CHARSET=%s\">\r\n", HTML_CHARSET);
	if (strlen(config.stylesheet)) {
		printf("<LINK REL=\"stylesheet\" TYPE=\"text/css\" HREF=\"%s\">\r\n", config.stylesheet);
	} else {
		printf("<STYLE>\r\n");
		printf("A        { color:%s; text-decoration:none }\r\n", config.colour_links);
		printf("A:HOVER  { text-decoration:underline }\r\n");
		printf(".JUSTIFY { text-align:justify }\r\n");
		printf(".TBAR    { color:#505050; font-size:8pt; font-family:Geneva,Arial,Verdana,Sans-Serif; text-decoration:none; }\r\n");
		printf("</STYLE>\r\n");
	}
	if (strncmp(request.RequestURI, "/mailwrite", 10)==0) {
		printf("<SCRIPT LANGUAGE=JavaScript SRC=%swmedit.js TYPE=text/javascript></SCRIPT>\r\n", config.base_image_url);
	}
	printf("</HEAD>\r\n");
	printf("<BODY BGCOLOR=\"%s\" COLOR=\"#000000\" LINK=\"%s\" ALINK=\"%s\" VLINK=\"%s\"", config.colour_bodybg, config.colour_links, config.colour_links, config.colour_links);
	printf(" TOPMARGIN=0 LEFTMARGIN=0 BOTTOMMARGIN=0 RIGHTMARGIN=0 MARGINHEIGHT=0 MARGINWIDTH=0>\r\n");

	if (wmserver_connect()!=0) return;

	memset(field, 0, sizeof(field));
	if ((ptemp=getgetenv("FIELD"))!=NULL) {
		snprintf(field, sizeof(field)-1, "%s", ptemp);
	}
	printf("<SCRIPT TYPE=\"text/javascript\" LANGUAGE=\"JavaScript\"><!--\r\n");
	printf("function SendTo(field, name, addr) {\r\n");
	printf("	var rcpt=\"\\\"\"+name+\"\\\" <\"+addr+\">\";\r\n\r\n");
	printf("	if (field==\"cc\") {\r\n");
	printf("		if (window.opener.document.wmcompose.cc.value!=\"\") {\r\n");
	printf("			window.opener.document.wmcompose.cc.value+=\", \"+rcpt;\r\n");
	printf("		} else {\r\n");
	printf("			window.opener.document.wmcompose.cc.value=rcpt;\r\n");
	printf("		}\r\n");
	printf("	} else if (field==\"bcc\") {\r\n");
	printf("		if (window.opener.document.wmcompose.bcc.value!=\"\") {\r\n");
	printf("			window.opener.document.wmcompose.bcc.value+=\", \"+rcpt;\r\n");
	printf("		} else {\r\n");
	printf("			window.opener.document.wmcompose.bcc.value=rcpt;\r\n");
	printf("		}\r\n");
	printf("	} else {\r\n");
	printf("		if (window.opener.document.wmcompose.to.value!=\"\") {\r\n");
	printf("			window.opener.document.wmcompose.to.value+=\", \"+rcpt;\r\n");
	printf("		} else {\r\n");
	printf("			window.opener.document.wmcompose.to.value=rcpt;\r\n");
	printf("		}\r\n");
	printf("	}\r\n");
	printf("}\r\n");
	printf("function SendToAll() {\r\n");
	printf("	var entries=document.mailform.elements.length/3;\r\n\r\n");
	printf("	for (var i=0;i<entries;i++) {\r\n");
	printf("		if (document.mailform[\"option\"+i].value=='TO') {\n");
	printf("			SendTo('to', document.mailform[\"name\"+i].value, document.mailform[\"addr\"+i].value);\r\n");
	printf("		} else if (document.mailform[\"option\"+i].value=='CC') {\n");
	printf("			SendTo('cc', document.mailform[\"name\"+i].value, document.mailform[\"addr\"+i].value);\r\n");
	printf("		} else if (document.mailform[\"option\"+i].value=='BCC') {\n");
	printf("			SendTo('bcc', document.mailform[\"name\"+i].value, document.mailform[\"addr\"+i].value);\r\n");
	printf("		}\r\n");
	printf("	}\r\n");
	printf("	window.close();\r\n");
	printf("}\r\n");
	printf("//--></SCRIPT>\r\n");
	if ((sqr=sql_query("SELECT contactid, surname, givenname, email1 from nwm_contacts WHERE owner_user = \"%s\" AND owner_host = \"%s\" ORDER BY surname, givenname ASC", user.username, user.pop3server))<0) return;
	if (sql_numtuples(sqr)<1) {
		sql_freeresult(sqr);
		printf("no addresses found");
		return;
	}
	printf("<CENTER>\n");
	printf("<TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0 WIDTH=100%%><TR>\n");
	printf("<TD ALIGN=RIGHT NOWRAP><A HREF=\"javascript:SendToAll()\">Add Recipients</A></TD>");
	printf("</TR></TABLE>\n");
	printf("<TABLE BORDER=0 CELLPADDING=1 CELLSPACING=1 WIDTH=100%%>\r\n");
	printf("<FORM METHOD=GET NAME=mailform>\n");
	j=0;
	printf("<TR BGCOLOR=\"%s\"><TH ALIGN=LEFT NOWRAP>&nbsp;<FONT COLOR=%s>%s</FONT>&nbsp;</TH><TH ALIGN=LEFT COLSPAN=2 NOWRAP>&nbsp;<FONT COLOR=%s>%s</FONT>&nbsp;</TH></TR>\n", config.colour_trim, config.colour_trimtext, "Contact Name", config.colour_trimtext, "E-Mail");
	for (i=0;i<sql_numtuples(sqr);i++) {
		if (strlen(sql_getvalue(sqr, i, 3))<1) continue;
		if (strchr(sql_getvalue(sqr, i, 3), '@')==NULL) continue;
		memset(realname1, 0, sizeof(realname1));
		memset(realname2, 0, sizeof(realname2));
		strncpy(realname1, sql_getvalue(sqr, i, 1), sizeof(realname1)-1);
		if (strlen(sql_getvalue(sqr, i, 1))&&strlen(sql_getvalue(sqr, i, 2))) strncat(realname1, ", ", sizeof(realname1)-strlen(realname1)-1);
		strncat(realname1, sql_getvalue(sqr, i, 2), sizeof(realname1)-strlen(realname1)-1);
		strncpy(realname2, sql_getvalue(sqr, i, 2), sizeof(realname2)-1);
		if (strlen(sql_getvalue(sqr, i, 1))&&strlen(sql_getvalue(sqr, i, 2))) strncat(realname2, " ", sizeof(realname2)-strlen(realname2)-1);
		strncat(realname2, sql_getvalue(sqr, i, 1), sizeof(realname2)-strlen(realname2)-1);
		printf("<TR BGCOLOR=\"%s\">", config.colour_ftext);
		printf("<TD NOWRAP>%s&nbsp;</TD>", str2html(realname1));
		printf("<TD NOWRAP WIDTH=100%%><A HREF=\"javascript:SendTo('%s', '%s', '%s'); window.close();\">%s</A>&nbsp;</TD>", field, realname2, sql_getvalue(sqr, i, 3), str2html(sql_getvalue(sqr, i, 3)));
		printf("<INPUT TYPE=hidden NAME=name%d VALUE=\"%s\">", j, realname2);
		printf("<INPUT TYPE=hidden NAME=addr%d VALUE=\"%s\">", j, sql_getvalue(sqr, i, 3));
		printf("<TD NOWRAP><SELECT NAME=option%d STYLE='font-size:10px; width:44px'>", j);
		printf("<OPTION VALUE=''>");
		if (strchr(sql_getvalue(sqr, i, 3), '@')) {
			printf("<OPTION VALUE='TO'>TO");
			printf("<OPTION VALUE='CC'>CC");
			printf("<OPTION VALUE='BCC'>BCC");
		}
		printf("</SELECT></TD></TR>\n");
		j++;
	}
	printf("</FORM></TABLE>\n");
	printf("<TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0 WIDTH=100%%><TR>\n");
	printf("<TD ALIGN=RIGHT NOWRAP><A HREF=\"javascript:SendToAll()\">Add Recipients</A></TD>");
	printf("</TR></TABLE>\n");
	printf("</CENTER>\n");
	sql_freeresult(sqr);
//	printfooter();
	return;
}

void wmaddr_edit()
{
	REC_CONTACT contact;
	char *ptemp;
	int contactid;

	printheader();
	if (wmserver_connect()!=0) goto footer;
	if (strncmp(request.RequestURI, "/addresseditnew", 15)==0) {
		contactid=0;
		dbread_contact(&contact, 0);
	} else {
		if ((ptemp=getgetenv("CONTACTID"))==NULL) goto footer;
		contactid=atoi(ptemp);
		if (dbread_contact(&contact, contactid)!=0) {
			printf("<CENTER>No matching record found for %d</CENTER>\n", contactid);
			goto footer;
		}
	}
	printf("<SCRIPT LANGUAGE=JavaScript>\n<!--\n");
	printf("function ConfirmDelete() {\n");
	printf("	return confirm(\"Are you sure you want to delete this record?\");\n");
	printf("}\n");
	printf("// -->\n</SCRIPT>\n");
	printf("<CENTER>\n<BR>\n");
	printf("<FORM METHOD=POST ACTION=%s/addresssave NAME=contactedit>\n", request.ScriptName);
	printf("<TABLE BORDER=0 CELLPADDING=2 CELLSPACING=0 WIDTH=350>\n");
	printf("<INPUT TYPE=hidden NAME=contactid VALUE='%d'>\n", contactid);
	if (contactid!=0) {
		printf("<TR BGCOLOR=\"%s\"><TH COLSPAN=2 NOWRAP>&nbsp;<FONT COLOR=\"%s\">Contact %d</FONT>&nbsp;</TH></TR>\n", config.colour_trim, config.colour_trimtext, contact.contactid);
	} else {
		printf("<TR BGCOLOR=\"%s\"><TH COLSPAN=2 NOWRAP>&nbsp;<FONT COLOR=\"%s\">New Contact</FONT>&nbsp;</TH></TR>\n", config.colour_trim, config.colour_trimtext);
	}
	printf("<TR BGCOLOR=\"%s\"><TD NOWRAP><B>&nbsp;NickName      &nbsp;</B></TD><TD ALIGN=RIGHT STYLE='padding:0px'><INPUT TYPE=TEXT NAME=nickname     value=\"%s\" SIZE=40></TD></TR>\n", config.colour_editform, str2html(contact.nickname));
	printf("<TR BGCOLOR=\"%s\"><TD NOWRAP><B>&nbsp;Surname       &nbsp;</B></TD><TD ALIGN=RIGHT STYLE='padding:0px'><INPUT TYPE=TEXT NAME=surname      value=\"%s\" SIZE=40></TD></TR>\n", config.colour_editform, str2html(contact.surname));
	printf("<TR BGCOLOR=\"%s\"><TD NOWRAP><B>&nbsp;Given Name    &nbsp;</B></TD><TD ALIGN=RIGHT STYLE='padding:0px'><INPUT TYPE=TEXT NAME=givenname    value=\"%s\" SIZE=40></TD></TR>\n", config.colour_editform, str2html(contact.givenname));
	printf("<TR BGCOLOR=\"%s\"><TD NOWRAP><B>&nbsp;E-Mail 1      &nbsp;</B></TD><TD ALIGN=RIGHT STYLE='padding:0px'><INPUT TYPE=TEXT NAME=email1       value=\"%s\" SIZE=40></TD></TR>\n", config.colour_editform, str2html(contact.email1));
	printf("<TR BGCOLOR=\"%s\"><TD NOWRAP><B>&nbsp;E-Mail 2      &nbsp;</B></TD><TD ALIGN=RIGHT STYLE='padding:0px'><INPUT TYPE=TEXT NAME=email2       value=\"%s\" SIZE=40></TD></TR>\n", config.colour_editform, str2html(contact.email2));
	printf("<TR BGCOLOR=\"%s\"><TD NOWRAP><B>&nbsp;Home Number   &nbsp;</B></TD><TD ALIGN=RIGHT STYLE='padding:0px'><INPUT TYPE=TEXT NAME=homenumber   value=\"%s\" SIZE=40></TD></TR>\n", config.colour_editform, str2html(contact.homenumber));
	printf("<TR BGCOLOR=\"%s\"><TD NOWRAP><B>&nbsp;Work Number   &nbsp;</B></TD><TD ALIGN=RIGHT STYLE='padding:0px'><INPUT TYPE=TEXT NAME=worknumber   value=\"%s\" SIZE=40></TD></TR>\n", config.colour_editform, str2html(contact.worknumber));
	printf("<TR BGCOLOR=\"%s\"><TD NOWRAP><B>&nbsp;Mobile Number &nbsp;</B></TD><TD ALIGN=RIGHT STYLE='padding:0px'><INPUT TYPE=TEXT NAME=mobilenumber value=\"%s\" SIZE=40></TD></TR>\n", config.colour_editform, str2html(contact.mobilenumber));
	printf("<TR BGCOLOR=\"%s\"><TD NOWRAP><B>&nbsp;FAX Number    &nbsp;</B></TD><TD ALIGN=RIGHT STYLE='padding:0px'><INPUT TYPE=TEXT NAME=faxnumber    value=\"%s\" SIZE=40></TD></TR>\n", config.colour_editform, str2html(contact.faxnumber));
	printf("</TABLE>\n");
	printf("<INPUT TYPE=SUBMIT CLASS=frmButton NAME=submit VALUE='Save'>\n");
	if (contactid>0) {
		printf("<INPUT TYPE=SUBMIT CLASS=frmButton NAME=submit VALUE='Delete' onClick=\"return ConfirmDelete();\">\n");
	}
	printf("</FORM>\n");
	printf("</CENTER>\n");
	printf("<SCRIPT LANGUAGE=JavaScript>\n<!--\ndocument.contactedit.nickname.focus();\n// -->\n</SCRIPT>\n");
footer:
	printfooter();
	return;
}

void wmaddr_list()
{
	signed char bgtoggle=0;
	unsigned int numaddr=0;
	int i, j;
	int sqr;

	printheader();
	printf("<CENTER>\n<BR>\n");
	if (wmserver_connect()!=0) goto footer;
	if ((sqr=sql_query("SELECT contactid, surname, givenname, email1 from nwm_contacts WHERE owner_user = \"%s\" AND owner_host = \"%s\" ORDER BY owner_host, surname, givenname ASC", user.username, user.pop3server))<0) return;
	if (sql_numtuples(sqr)<1) {
		sql_freeresult(sqr);
		printf("no addresses found<BR>");
		goto footer;
	}
	numaddr=sql_numtuples(sqr);
	if (numaddr>0) {
		printf("<TABLE BORDER=0 CELLPADDING=1 CELLSPACING=1 WIDTH=90%%>\r\n");
		if (numaddr<config.max_addresses) {
			printf("<TR><TD ALIGN=RIGHT COLSPAN=3><A HREF=\"%s/addresseditnew\">New Contact</A></TD></TR>\n", request.ScriptName);
		}
		printf("<TR BGCOLOR=\"%s\"><TH>&nbsp;</TH><TH ALIGN=LEFT NOWRAP>&nbsp;<FONT COLOR=%s>%s</FONT>&nbsp;</TH><TH ALIGN=LEFT NOWRAP>&nbsp;<FONT COLOR=%s>%s</FONT>&nbsp;</TH></TR>\n", config.colour_trim, config.colour_trimtext, "Contact Name", config.colour_trimtext, "E-Mail");
		j=0;
		for (i=0;i<sql_numtuples(sqr);i++) {
			if ((bgtoggle=abs(bgtoggle-1))==0) {
				printf("<TR BGCOLOR=\"%s\">", config.colour_mlisteven);
			} else {
				printf("<TR BGCOLOR=\"%s\">", config.colour_mlistodd);
			}
			printf("<TD NOWRAP><A HREF=\"%s/addressedit?contactid=%d\">edit</A></TD>", request.ScriptName, atoi(sql_getvalue(sqr, i, 0)));
			printf("<TD NOWRAP><A HREF=\"%s/addressedit?contactid=%d\">%s", request.ScriptName, atoi(sql_getvalue(sqr, i, 0)), str2html(sql_getvalue(sqr, i, 2)));
			printf(" %s</A></TD>", str2html(sql_getvalue(sqr, i, 1)));
			printf("<TD NOWRAP WIDTH=100%%><A HREF=\"%s/mailwrite?to=%s\">%s", request.ScriptName, sql_getvalue(sqr, i, 3), str2html(sql_getvalue(sqr, i, 3)));
			printf("</TR>\n");
			j++;
		}
		if (numaddr<config.max_addresses) {
			printf("<TR><TD ALIGN=RIGHT COLSPAN=3><A HREF=\"%s/addresseditnew\">New Contact</A></TD></TR>\n", request.ScriptName);
		}
		printf("</TABLE>\n");
	}
	sql_freeresult(sqr);
footer:
	if (numaddr==0) {
		printf("<A HREF=\"%s/addresseditnew\">New Contact</A>\n", request.ScriptName);
	}
	printf("</CENTER>\n");
	printfooter();
	return;
}

void wmaddr_save()
{
	REC_CONTACT contact;
	char *ptemp;
	char curdate[40];
	char query[2048];
	int contactid;
	unsigned int numaddr=0;
	time_t t;
	int sqr;

	printheader();
	if (wmserver_connect()!=0) goto fini;
	if (strcmp(request.RequestMethod,"POST")!=0) {
		printf("<BR><CENTER>Permission Denied</CENTER><BR>\n");
		goto fini;
	}
	if ((ptemp=getpostenv("CONTACTID"))==NULL) {
		printf("<BR><CENTER>Permission Denied</CENTER><BR>\n");
		goto fini;
	}
	contactid=atoi(ptemp);
	if (dbread_contact(&contact, contactid)!=0) {
		printf("<BR><CENTER>Permission Denied</CENTER><BR>\n");
		goto fini;
	}
	if ((ptemp=getpostenv("NICKNAME"))!=NULL)	snprintf(contact.nickname,     sizeof(contact.nickname)-1, "%s", ptemp);
	if ((ptemp=getpostenv("SURNAME"))!=NULL)	snprintf(contact.surname,      sizeof(contact.surname)-1, "%s", ptemp);
	if ((ptemp=getpostenv("GIVENNAME"))!=NULL)	snprintf(contact.givenname,    sizeof(contact.givenname)-1, "%s", ptemp);
	if ((ptemp=getpostenv("EMAIL1"))!=NULL)		snprintf(contact.email1,       sizeof(contact.email1)-1, "%s", ptemp);
	if ((ptemp=getpostenv("EMAIL2"))!=NULL)		snprintf(contact.email2,       sizeof(contact.email2)-1, "%s", ptemp);
	if ((ptemp=getpostenv("HOMENUMBER"))!=NULL)	snprintf(contact.homenumber,   sizeof(contact.homenumber)-1, "%s", ptemp);
	if ((ptemp=getpostenv("WORKNUMBER"))!=NULL)	snprintf(contact.worknumber,   sizeof(contact.worknumber)-1, "%s", ptemp);
	if ((ptemp=getpostenv("MOBILENUMBER"))!=NULL)	snprintf(contact.mobilenumber, sizeof(contact.mobilenumber)-1, "%s", ptemp);
	if ((ptemp=getpostenv("FAXNUMBER"))!=NULL)	snprintf(contact.faxnumber,    sizeof(contact.faxnumber)-1, "%s", ptemp);
	memset(curdate, 0, sizeof(curdate));
	memset(query, 0, sizeof(query));
	t=time(NULL);
	strftime(curdate, strlen(curdate)-1, "%Y-%m-%d %H:%M:%S", gmtime(&t));
	if (((ptemp=getpostenv("SUBMIT"))!=NULL)&&(strcmp(ptemp, "Delete")==0)) {
		if (sql_update("DELETE FROM nwm_contacts WHERE contactid = %d", contact.contactid)<0) goto fini;
		printf("<CENTER>Contact %d deleted successfully</CENTER><BR>\n", contact.contactid);
	} else if (contact.contactid==0) {
		if ((sqr=sql_query("SELECT count(contactid) FROM nwm_contacts WHERE owner_user = \"%s\" AND owner_host = \"%s\"", user.username, user.pop3server))<0) goto fini;
		numaddr=atoi(sql_getvalue(sqr, 0, 0));
		sql_freeresult(sqr);
		if (numaddr>=config.max_addresses) {
			printf("<CENTER>Maximum number of addressbook entries already reached</CENTER><BR>\n");
			goto fini;
		}
		strcpy(query, "INSERT INTO nwm_contacts (contactid, obj_ctime, obj_mtime, owner_user, owner_host, nickname, surname, givenname, email1, email2, homenumber, worknumber, mobilenumber, faxnumber) values (");
		strncatf(query, sizeof(query)-strlen(query)-1, "'%d', '%s', '%s', ", contact.contactid, curdate, curdate);
		strncatf(query, sizeof(query)-strlen(query)-1, "'%s', ", str2sql(user.username));
		strncatf(query, sizeof(query)-strlen(query)-1, "'%s', ", str2sql(user.pop3server));
		strncatf(query, sizeof(query)-strlen(query)-1, "'%s', ", str2sql(contact.nickname));
		strncatf(query, sizeof(query)-strlen(query)-1, "'%s', ", str2sql(contact.surname));
		strncatf(query, sizeof(query)-strlen(query)-1, "'%s', ", str2sql(contact.givenname));
		strncatf(query, sizeof(query)-strlen(query)-1, "'%s', ", str2sql(contact.email1));
		strncatf(query, sizeof(query)-strlen(query)-1, "'%s', ", str2sql(contact.email2));
		strncatf(query, sizeof(query)-strlen(query)-1, "'%s', ", str2sql(contact.homenumber));
		strncatf(query, sizeof(query)-strlen(query)-1, "'%s', ", str2sql(contact.worknumber));
		strncatf(query, sizeof(query)-strlen(query)-1, "'%s', ", str2sql(contact.mobilenumber));
		strncatf(query, sizeof(query)-strlen(query)-1, "'%s')", str2sql(contact.faxnumber));
		if (sql_update(query)<0) goto fini;
		printf("<CENTER>Contact added successfully</CENTER><BR>\n");
	} else {
		snprintf(query, sizeof(query)-1, "UPDATE nwm_contacts SET obj_mtime = '%s', ", curdate);
		strncatf(query, sizeof(query)-strlen(query)-1, "nickname = '%s', ",     str2sql(contact.nickname));
		strncatf(query, sizeof(query)-strlen(query)-1, "surname = '%s', ",      str2sql(contact.surname));
		strncatf(query, sizeof(query)-strlen(query)-1, "givenname = '%s', ",    str2sql(contact.givenname));
		strncatf(query, sizeof(query)-strlen(query)-1, "email1 = '%s', ",       str2sql(contact.email1));
		strncatf(query, sizeof(query)-strlen(query)-1, "email2 = '%s', ",       str2sql(contact.email2));
		strncatf(query, sizeof(query)-strlen(query)-1, "homenumber = '%s', ",   str2sql(contact.homenumber));
		strncatf(query, sizeof(query)-strlen(query)-1, "worknumber = '%s', ",   str2sql(contact.worknumber));
		strncatf(query, sizeof(query)-strlen(query)-1, "mobilenumber = '%s', ", str2sql(contact.mobilenumber));
		strncatf(query, sizeof(query)-strlen(query)-1, "faxnumber = '%s'",      str2sql(contact.faxnumber));
		strncatf(query, sizeof(query)-strlen(query)-1, " WHERE contactid = %d", contact.contactid);
		if (sql_update(query)<0) goto fini;
		printf("<CENTER>Contact %d modified successfully</CENTER><BR>\n", contact.contactid);
	}
	printf("<SCRIPT LANGUAGE=JavaScript TYPE=text/javascript>\n<!--\n");
	printf("location.replace(\"%s/addresslist\");\n", request.ScriptName);
	printf("// -->\n</SCRIPT>\n");
	printf("<NOSCRIPT>\n");
	printf("<META HTTP-EQUIV=\"Refresh\" CONTENT=\"0; URL=%s/addresslist\">\n", request.ScriptName);
	printf("</NOSCRIPT>\n");
fini:
	printfooter();
	return;
}

#endif // HAVE_ADDRESSBOOK
